<template>
  <div>
    <p class="text-h4 mb-10">
      Registra una nueva cita
    </p>
    <stepper :step="step">
      <v-stepper-content step="1" class="pa-0 pa-md-5">
        <v-tabs
          color="primary"
          @change="reset"
        >
          <v-tab>Por Fecha</v-tab>
          <v-tab>Por Especialista</v-tab>

          <v-tab-item
            v-for="n in 2"
            :key="n"
          >
            <div v-if="n ===1" style="padding: 15px">
              <search-by-date
                :specialists-available="specialistsAvailable"
                :selected-id-schedule="selectedIdSchedule"
                :index-availavility="indexAvailavility"
                :specialist-selected="specialistSelected"
                :availability="selectedIdSchedule"
                :index-selected="indexSpecialist"
                @getPosAvailability="getPosAvailability"
                @getHour="getHour"
                @getUuidSpecialist="getUuidSpecialist"
                @getPosSpecialist="getPosSpecialist"
                @getAvailability="getAvailabilityRange"
                @changeStep="step = 2"
                @searchAvailability="searchAvailability"
              />
            </div>
            <div v-else style="padding: 15px">
              <search-by-specialist
                :specialists-available="specialists.data"
                :selected-specialist="specialistSelected ? specialistSelected : specialists.data ? specialists.data[0] : null"
                :availability="specialistsAvailable"
                :select-availability="selectAvailability"
                :time="timeSelected"
                @selectSpecialist="selectSpecialist"
                @getAvailability="getAvailability"
                @changeStep="() => {
                  if(specialistSelected===null) specialistSelected = specialists.data[0];
                  step = 2;
                }"
              />
            </div>
          </v-tab-item>
        </v-tabs>
      </v-stepper-content>
      <v-stepper-content step="2" class="pa-0 pa-md-5">
        <initial-questionnaire
          :on-change-one="firstQuestion"
          :on-change-two="secondQuestion"
          :reasons="this.reasons"
          :on-change-three="thirdQuestion"
        />
        <v-row align="center" class="v-container-button">
          <v-col cols="6" class="text-right">
            <v-btn color="primary" large rounded outlined @click="step = 1">
              Regresar
            </v-btn>
          </v-col>
          <v-col cols="6" class="text-left">
            <v-btn
              v-if="answerOne"
              large
              color="primary"
              rounded
              @click="step = 3"
            >
              Continuar
            </v-btn>
          </v-col>
        </v-row>
      </v-stepper-content>
      <v-stepper-content
        v-if="!loading"
        step="3"
        class="pa-0 pa-md-5"
      >
        <resume
          :date="formatDate(dateSelected)"
          :time-selected="timeSelected"
          :specialist="specialistSelected"
          :index-availability="indexAvailavility"
          :tab="optionSelected"
        />
        <v-row align="center" class="v-container-button">
          <v-col cols="6" class="text-right">
            <v-btn color="primary" large rounded outlined @click="step = 2">
              Regresar
            </v-btn>
          </v-col>
          <v-col cols="6" class="text-left">
            <v-btn color="primary" large rounded @click="registerReservation">
              Reservar
            </v-btn>
          </v-col>
        </v-row>
      </v-stepper-content>
    </stepper>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';
import moment from 'moment-timezone';
import { formatAMPM } from '~/helpers/time';
import Stepper from '~/components/Steppers/Stepper.vue';
import InitialQuestionnaire from '~/components/Questionnaire/InitialQuestionnaire.vue';
import AppointmentResume from '~/components/Resume/AppointmentResume.vue';
import SearchByDateVue from '~/components/Sections/Appointments/SearchByDate.vue';
import SearchBySpecialistVue from '~/components/Sections/Appointments/SearchBySpecialist.vue';

export default {
  name: 'BookAppointment',
  components: {
    stepper: Stepper,
    'search-by-date': SearchByDateVue,
    'search-by-specialist': SearchBySpecialistVue,
    'initial-questionnaire': InitialQuestionnaire,
    resume: AppointmentResume,
  },
  data() {
    return {
      currentDate: null,
      pacient: {
        name: 'Marco Quezada',
        image:
          'https://pps.whatsapp.net/v/t61.24694-24/121674332_819884682100984_1670862998742054095_n.jpg?ccb=11-4&oh=440fba5eaaffbed8a6618cce8ec0b2c8&oe=60B401D6',
      },
      step: 1,
      timeSelected: null,
      specialistSelected: null,
      dateSelected: moment()
        .tz('America/Lima')
        .format()
        .slice(0, 10),
      answerOne: null,
      answerTwo: null,
      answerThree: null,
      selectedTime: null,
      specialistResume: {
        name: null,
        image: null,
        rating: null,
        availability: [],
      },
      selectedIdSchedule: null,
      indexSpecialist: -1,
      indexAvailavility: -1,
      confirmDialog: false,
      startDate: null,
      endDate: null,
      optionSelected: 0,
    };
  },
  computed: {
    ...mapState({
      specialistsAvailable: state =>
        state.patient.specialistAvailable.specialistsAvailable,
      loading: state => state.patient.specialistAvailable.loading,
      specialists: state => state.patient.specialistAvailable.specialists,
      reasons: state => state.appointments.reasons,
    }),
    ...mapGetters({
      myUserUuid: 'auth/myUserUuid',
    }),
  },
  mounted() {
    this.currentDate = new Intl.DateTimeFormat('az', {
      year: 'numeric',
      month: '2-digit',
      day: '2-digit',
    }).format(new Date());
    const today = moment();
    this.startDate = today.tz('America/Lima').format().substring(0, 10);
    this.endDate = today.tz('America/Lima').format().substring(0, 10);
    this.getAllSpecialists(today.tz('America/Lima').format().substring(0, 10), today.tz('America/Lima').format().substring(0, 10));
    this.getReasonPreAppointment();
  },
  methods: {
    ...mapActions({
      getSpecialists: 'patient/specialistAvailable/getSpecialists',
      getAllSpecialistsList: 'patient/specialistAvailable/getAllSpecialists',
      getSpecialistsAvailability: 'patient/specialistAvailable/getSpecialistsAvailability',
      registerAppointment: 'patient/specialistAvailable/registerAppointment',
      registerVideoCall: 'videocall/videocalls/registerVideoCall',
      getReasonPreAppointment: 'appointments/getReasonPreAppointment',
      registerPrePoll: 'appointments/registerPrePoll',
    }),
    getPosAvailability(e) {
      this.indexAvailavility = e;
    },
    selectAvailability(index, startTime, endTime) {
      const availableIni = formatAMPM(startTime);
      const availableFin = formatAMPM(endTime);
      this.timeSelected = availableIni + ' a ' + availableFin;
      const date = new Intl.DateTimeFormat('en-US', {
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
      }).format(startTime);

      const [month, day, year] = date.split('/');
      this.dateSelected = `${year}-${month}-${day}`;
      this.selectedIdSchedule = index;
    },
    selectSpecialist(event) {
      this.specialistSelected = event;
    },
    registerReservation() {
      this.confirmDialog = true;
      const reservation = {
        idAvailability: this.selectedIdSchedule,
        uuidPatient: this.myUserUuid,
        uuidSpecialist: this.specialistSelected.user.uuid,
      };
      this.registerAppointment(reservation)
        .then((response) => {
          if (response.message) {
            this.$notifier.showMessage({ content: 'El horario escogido ya fue reservado, intente con otro', color: 'red' });
            this.step = 1;
          } else {
            this.$notifier.showMessage({ content: 'Cita registrada' });
            this.registerVideoCall({ appointmentId: response.data.id, patientUID: this.myUserUuid, specialistUID: this.specialistSelected.user.uuid });
            const cargaUtil = {
              'additionalInfo': this.answerThree,
              'anotherReason': this.answerTwo,
              'idMedicalReason': this.answerOne.idMedicalReason,
            };
            this.registerPrePoll({ idAppointment: response.data.id, payload: cargaUtil });
            this.$router.push('/paciente/sesion');
          }
        });
    },
    getHour(e) {
      console.log('IMPRIME LO QUE OBTIENES DEL EVENTO', e);
      this.selectedIdSchedule = e;
    },
    getUuidSpecialist(e) {
      console.log('IMPRIME EL UUID DEL RESULTADO', e);
      this.specialistSelected = e;
    },
    getPosSpecialist(day, e, indexAva) {
      this.indexSpecialist = day;
      console.log('ESPECIALISTA ESCOGIDO', this.specialistsAvailable[day].specialists[e]);
      this.specialistSelected = this.specialistsAvailable[day].specialists[e];
      const date = this.specialistsAvailable[day].specialists[e].availabilities[indexAva];
      console.log('HORARIO ESCOGIDO', date);
      const daySel = date.startTime.substring(0, 10);
      console.log('HORARIO ESCOGIDO DIA', daySel);
      this.dateSelected = daySel;
      const availableIni = formatAMPM(new Date(date.startTime));
      const availableFin = formatAMPM(new Date(date.endTime));
      // new Intl.DateTimeFormat('es-Es', { hour: '2-digit', minute: '2-digit' }).format(new Date(date.endTime)) + ' Horas';
      const time = availableIni + ' a ' + availableFin;
      console.log('HORARIO ESCOGIDO HORAS', time);
      this.timeSelected = time;
    },
    getAllSpecialists(startDate, endDate) {
      this.getSpecialistsAvailability({ startDate, endDate });
      this.getAllSpecialistsList();
    },
    formatDate(date) {
      if (!date) {
        return null;
      }
      const weekDayName = moment(date).locale('es').format('dddd');
      const capitalizewd = weekDayName[0].toUpperCase() + weekDayName.slice(1);
      const [year, month, day] = date.split('-');
      const months = [
        'enero',
        'febrero',
        'marzo',
        'abril',
        'mayo',
        'junio',
        'julio',
        'agosto',
        'setiembre',
        'octubre',
        'noviembre',
        'diciembre',
      ];
      return `${capitalizewd} ${day} de ${months[month - 1]} del ${year}`;
    },
    searchAvailability(dates) {
      if (dates.type === 'start') {
        this.getAllSpecialists(dates.date, this.endDate);
        this.startDate = dates.date;
      } else {
        this.getAllSpecialists(this.startDate, dates.date);
        this.endDate = dates.date;
      }
      console.log('DATE', dates);
    },
    getAvailability(event) {
      if (event === undefined || event.id === '') {
        this.specialistSelected = null;
      } else {
        console.log('especialista seleccionado', event.uuid);
        this.specialistSelected = event.uuid;
        this.getAvailabilityRange(this.dateSelected, this.endDateSelected);
      }
    },
    getAvailabilityRange(event) {
      if (event === undefined || event.id === '') {
        this.specialistSelected = null;
      } else {
        console.log('dias', event);
        this.getSpecialistsAvailability(this.dateSelected, this.endDateSelected);
      }
    },
    firstQuestion(event) {
      console.log('PRIMERA', event);
      this.answerOne = event;
    },
    secondQuestion(event) {
      console.log(event);
      this.answerTwo = event;
    },
    thirdQuestion(event) {
      console.log(event);
      this.answerThree = event;
    },
    reset(event) {
      this.optionSelected = event;
    },
  },
};
</script>
<style scoped>
.v-container-button {
  margin-bottom: 10px;
}
</style>
